<?php
// $Id: views_plugin_display_adly.inc,v 1.1.2.3 2010/09/29 22:57:34 inadarei Exp $
/**
 * @file
 * Contains the block display plugin injected with Adly configuration.
 */
 
module_load_include('inc', 'views', 'plugins/views_plugin_display_block');
module_load_include('inc', 'views', 'plugins/views_plugin_display_page');
module_load_include('inc', 'views', 'plugins/views_plugin_display_feed');


/**
* A delegate class. Allows avoiding massive code duplication.
*/
class adly_views_plugin_delegate {

  function option_definition(&$options) {
    $options['adly_position'] = array('default' => 'none');
    $options['adly_content_field'] = array('default' => 'none');	  
  	
    return $options;
  }

  function options_summary(&$categories, &$options) {
    $categories['adly'] = array(
      'title' => t('Adly Settings'),
    );

    $adly_position = strip_tags($this->get_option('adly_position'));
    if (empty($adly_position)) {
      $adly_position = t('None');
    }

    $options['adly_position'] = array(
      'category' => 'adly',
      'title' => t('Ad.ly Position'),
      'value' => $adly_position,
    );
    
    $options['adly_content_field'] = array(
      'category' => 'adly',
      'title' => t('Ad.ly Content Field'),
      'value' => $this->get_option('adly_content_field'),
    );
  }


  function options_form(&$form, &$form_state) {

    switch ($form_state['section']) {
    	case 'adly_position':
        $form['#title'] .= t('Ad.ly Ads Position');
		    $form['adly_position'] = array(
		      '#type' => 'radios',
		      '#title' => t('Ad.ly Ads Position'),
		      '#options' => array('none' => t('Disable Ad.ly Ads for this display'),
		      										'top' => t('At the Top [$attachment_before tpl variable]'), 
		      										'bottom' => t('At the Bottom [$attachment_after tpl variable]')),
		      '#default_value' => $this->get_option('adly_position'),
		    );
				break;
			case 'adly_content_field':
				$form['#title'] .= t('Ad.ly Content Field');
	      $options =  array('none' => t('<None>'));
	      $options += $this->display->handler->get_field_labels();
        $form['adly_content_field'] = array(
		      '#title' => t('Field containing the most important content [Usually: title or body]'),
		      '#type' => 'select',
		      '#options' => $options,
		      '#multiple' => FALSE,
		      '#required' => TRUE,
		      '#default_value' => $this->get_option('adly_content_field'),
		    );
		    break;
    }
  }

  function options_submit(&$form, &$form_state) {    
    switch ($form_state['section']) {
      case 'adly_position':
        $this->set_option('adly_position', $form_state['values']['adly_position']);
        break;
      case 'adly_content_field':
        $this->set_option('adly_content_field', $form_state['values']['adly_content_field']);
        break;        
    }
  }

  
}


/****** Specific Implementations (all of them are exactly the same except for name and which class they extend). ******/


/**
 * The plugin that handles a block.
 * @ingroup views_display_plugins
 */
class views_plugin_display_block_adly extends views_plugin_display_block {

  function option_definition() {
    $options = parent::option_definition();
    adly_views_plugin_delegate::option_definition($options);    
    return $options;
  }

  function options_summary(&$categories, &$options) {
    parent::options_summary($categories, $options);
    adly_views_plugin_delegate::options_summary($categories, $options);
  }

  function options_form(&$form, &$form_state) {
    // It is very important to call the parent function here:
    parent::options_form($form, $form_state);
    adly_views_plugin_delegate::options_form($form, $form_state);    
  }
  
  function options_submit(&$form, &$form_state) {
    parent::options_submit($form, $form_state);
    adly_views_plugin_delegate::options_submit($form, $form_state);    
  }

}

/**
 * The plugin that handles a block.
 * @ingroup views_display_plugins
 */
class views_plugin_display_page_adly extends views_plugin_display_page {

  function option_definition() {
    $options = parent::option_definition();
    adly_views_plugin_delegate::option_definition($options);    
    return $options;
  }

  function options_summary(&$categories, &$options) {
    parent::options_summary($categories, $options);
    adly_views_plugin_delegate::options_summary($categories, $options);
  }

  function options_form(&$form, &$form_state) {
    // It is very important to call the parent function here:
    parent::options_form($form, $form_state);
    adly_views_plugin_delegate::options_form($form, $form_state);    
  }
  
  function options_submit(&$form, &$form_state) {
    parent::options_submit($form, $form_state);
    adly_views_plugin_delegate::options_submit($form, $form_state);    
  }

}

/**
 * The plugin that handles a block.
 * @ingroup views_display_plugins
 */
class views_plugin_display_feed_adly extends views_plugin_display_feed {

  function option_definition() {
    $options = parent::option_definition();
    adly_views_plugin_delegate::option_definition($options);    
    return $options;
  }

  function options_summary(&$categories, &$options) {
    parent::options_summary($categories, $options);
    adly_views_plugin_delegate::options_summary($categories, $options);
  }

  function options_form(&$form, &$form_state) {
    // It is very important to call the parent function here:
    parent::options_form($form, $form_state);
    adly_views_plugin_delegate::options_form($form, $form_state);    
  }
  
  function options_submit(&$form, &$form_state) {
    parent::options_submit($form, $form_state);
    adly_views_plugin_delegate::options_submit($form, $form_state);    
  }

}
